;hotovo nacitani do RAM ,zaznam do EEPROM,porovnani dat pri prijmu s daty v RAM
; stmivani s optoclenem mezi triakem,je dodelane i zap nebo vyp, zapina v nule
;navic pro tvrde sepnuti pri funkci jen zap dodae cekani pro testovani napajeni paralelne k triaku

;v teto verzi je zcela zmeneno ovladani, aby nemusel byt pri regulaci stale vysilan telegram, protoze je nachylny k ruseni
;pracuje to tak, ze zap/vyp na kratky stisk je stejne. Pri delsim podrzeni tlacitka se zacnou zarovky rozsvicovat a zhasinat (od 0 do max. a obracene)
;a to tak dlouho, dokud se nestiskne kratce tlacitko, pak se tato cinnost zastavi a zarovky zustanou svitit nastavenym jasem
;dalsim kratkym stiskem se opet zarovky zhasnou 


        LIST P=16F628, R=DEC    ; Use the PIC16F628 and decimal system 

        #include "P16F628.INC"  ; Include header file 

        __config  _XT_OSC &_LVP_OFF & _WDT_OFF & _PWRTE_ON & _BODEN_OFF 

         
	constant initmrhi=0C7H		;pro test 00 predvolba timeru low
;	constant initmrhi=0F5H		;pro test 00 predvolba timeru low - pro ovl. od kamery ap.
	constant minimalni_jas=0E2H	;konstanta minimalniho jasu pro stmivac
								;maximalni jas nemenit !! zavisi na nem napajeni elektroniky pres kondenzator u triaku
	constant konst=05H	;velikost teto konstanty urcuje dobu,po jake se prejde pri drzeni tlacitka DO do rezimu stmivani
		

vys		equ	20H	;promenna pro ulozeni nizsiho byte timeru
tmp		equ	21H	;promenna pro ulozeni vyssiho byte timeru
TMPW	equ	22H	;docasna promenna pro ulozeni W v int.
TMPS	equ	23H	;totez jako vyse pro ulozeni status
flags	equ	24H	;registr pro flagy
AD0		equ	26H	;registr prvnich 4 pulintervalu
ok		equ	00H	;flag porovnani hodnoty
err		equ	01H	;flag porovnani hodnoty
stisk	equ	02H
druhy_kod	equ	03H
ulozeno	equ	04H
citac	equ	25H
;--------------pro stmivac-----------------------
initmrhi1	equ	6FH		;predvolba	65536-9900(min.) az 65536-2700(max.)
initmrlo1	equ 6EH
obehy		equ	6DH		;pocitadlo obehu pro rozliseni zda stmivat nebo zhasnout
stmivej		equ	05H			;flag pro zmenu stmivani / rozsveceni
svetlo		equ	06H			;flag pro rozsviceni, nastaven pri pozadavku svetla
prijato_ok	equ	07H			;flag nastaven po prijeti platneho (nahraneho kodu), vyuzito po preteceni casovace podruhe
							;protoze rutina zhasni je volana jak po ukonceni prijeti platneho tak i neplatneho kodu, a je nutno rozlisit, jestli 
							;ktery kod volani teto rutiny predchazel (pokud by se to nepouzilo, tak by po kazdem preteceni nasledovalo
							;rozsviceni nebo zhasnuti i po prijeti jedineho impulsu ze SFH a preteceni casovace)
tmphi		equ	6CH			;docasne ulozeni stavu promennych initmrhi1 pro rychle rozsviceni po zapnuti
							;u stmivace pro setreni zarovek
flags1		equ	6BH			;dalsi flagy
rozsviceno	equ	00H			;test pri zapnuti svetla, a rychlem rozsviceni zda uz bylo uplne rozsviceno
lustrak_uvolnen equ	01H		;priznak uvolneneho lustraku
TMP1		equ	6AH
TMP0		equ	69H
TMP2		equ	68H
TMP3		equ	67H
zpomal		equ	66H			;cislo v teto promenne ovlivnuje, jak rychle bude probyhat cyklus stmivani a rozsveceni pri nastavovani
porovnani	equ	65H
tim2		equ	64H

podruhe		equ	04H			;flag pro vyvolani casovani v zaporne pulvlne
spusteni	equ	05H
cykl		equ	06H			;flag	- nastavenim tohoto priznaku dojde k vyvolani nastavovaciho procesu
;----------------OBSAZENI PORTU-----------------------------------
#define	vst_fsh		PORTB,0	;vstup od SFH - externi preruseni
#define	tlacitko	PORTB,1	;pokud je v L, bude se zaznamenavat do RAM infra kod
#define	jumper		PORTB,2	;jumper na volbu modu zda stmivac nebo vypinac
#define	vypinac		PORTB,3	;vstup normalniho vypinace
				;	PORTB,5	vstup od pruchodu site nulou - preruseni pri zmene na portu B
#define	led_ulozeno	PORTA,0	;vystup na LED signalizujici ulozeni do EEPROM
#define	led			PORTA,1	;vystup na indikacni LED prijmuti prikazu 
#define	vyst_triak	PORTA,2	;vystup na optotriak
#define v_lustru	PORTB,4	;pokud je umisten v lustru, je spojen vyv. 10 PICu se zemi, cili L= v lustru		
							;muzu to pouzit jako vstup, protoze uroven se nemeni, cili INT zmenou na portu B odsud nebude vyvolavano
							;dle uzivatele bude bud volny (pres pull up do H) nebo v L

 ORG    0x000            ; Program starts at 0x000 
 		goto init
	ORG 4			;preruseni
	goto int1


int1
;-------------uloz data-----------------
	movwf	TMPW		; ulozi W
	swapf	STATUS,W	; prohodi nibble STATUS a ulozi do W
	bcf	STATUS,RP0	; nastaveni banky 0
	movwf	TMPS		; ulozit STATUS
;---------------------------------------

;-----zjisti vektor preruseni-----------------
	bcf STATUS, RP0 ; Bank0
	
	btfsc PIR1,TMR1IF ;prislo preruseni od preteceni casovace 1 ?
	goto timer1		;ano,obsluz
	
	btfsc	PIR1,TMR2IF ;prislo preruseni od preteceni casovace 2 ?
	goto timer2		;ano,obsluz
	
	btfsc	INTCON,INTF	;prislo preruseni od RB0/INT	- SFH 506	
	goto	external
	
	
	btfss INTCON,RBIF ;prislo preruseni od zmeny na portu B ?	- pruchod site nulou
	goto timer		;ne,obsluz casovac 0
;---odjinud INT nemohlo prijit, vice se netestuje
	;timto testem se uschova initmrhi1 a initmrlo1 a inkrementuje se predvolba tak,aby se pri kazdem pruchodu site nulou zvysila 
	;hodnota, t.j. pri kazdem pruchodu site se rozsviti vic a vic a az sviti tak jako je pozadavek uschovane predvolby initmrhi1 a lo1, nastavi 
	;priznak rozsviceno, tim se uzavre vstup do teto rutiny
	
	btfsc	PORTB,5				;testuj hranu signalu, pokud je vzestupna pokracuj	
	goto	navrat
	
	btfsc	flags1,rozsviceno	;testuj flag uplneho rozsviceni (dosazeni predvolby po zapnuti)
	goto	pokr_09				;rozsviceno, pokracuj normalne dale
	btfss	flags,svetlo
	goto	pokr_09
	incf	initmrhi1,F			;inkremetuj predvolbu
	movf	initmrhi1,W			;nacti pro test
	subwf	tmphi,W				;odecti 
	btfss	STATUS,Z			;testuj dosazeni vysledku
	goto	pokr_09
	bsf		flags1,rozsviceno	;je dosazeno

pokr_09
	
	movlw	10H
	movwf	porovnani
	clrf	TMR2
	clrf	tim2
	bsf	T2CON,TMR2ON		;spust casovac
	
	
	
	bcf		flags1,podruhe		;nuluj flag pro prvni vykonani casovani
	call	timini1		;nacti predvolbu
	movf	PORTB,W		;pro INT zmenou urovne na portu B se musi port B cist (i kdyz se to zahodi)
	bcf		INTCON,	RBIF

	btfss	jumper		;zde se testuje, zda budeme pracovat v modu stmivani nebo jen jako spinac,pokud spinac, ihned po prichodu nuly site se 
						;zapne triak, jinak se spusti casovac
	goto	spinac
	bsf 	T1CON,TMR1ON ; Timer1 ON
	
	decfsz	zpomal,F		;dekrementuj zpomalovaci byte
	 goto	IntRet

	movlw	03H
	movwf	zpomal
	
	btfss	flags1,cykl	
	goto	IntRet
	
	btfsc	flags,stmivej	;testuj, zda stmivat nebo rozsvicovat,nastaven bude se stmivat
	goto	stmivat	
	movlw	040H
	addwf	initmrlo1,F		;rozsvicovat
	btfss	STATUS,Z		;preteceni initmrlo1,inkrementuj initmrhi1,inkrementace po 40H
	goto	IntRet
	incf	initmrhi1,F
	movf	initmrhi1,W		;nacti hodnotu predvolby
	sublw	0FBH			;testuj dosazeni maxima (0F5H+1 navic) pro jistotu radsi vic pro opravdu maximum
	btfsc	STATUS,Z		;testuj zero
	bsf		flags,stmivej
	goto	IntRet
	
stmivat
	movlw	040H
	subwf	initmrlo1,F		;rozsvicovat
	btfsc	STATUS,C		;preteceni initmrlo1,dekrementuj initmrhi1,dekrementace po 40H
	goto	IntRet
	decf	initmrhi1,F
	movf	initmrhi1,W		;nacti hodnotu predvolby
	sublw	minimalni_jas	;testu dosazeni minima 
	btfsc	STATUS,Z		;testuj zero
	bcf		flags,stmivej
	goto	IntRet	

navrat
	movf	PORTB,W
	bcf		INTCON,	RBIF
	goto	IntRet


;
;---------------TOTO JEN PRI POZADAVKU PRACE JAKO SPINAC NE JAKO STMIVAC !!!------------
spinac
;tady se zapne triak. Kvuli napajeni elektroniky se ale nezapne ihned po pruchodu nulou ale az po
;case FD44H t.j. tedy az po 700 mikrosec. 	
	btfss	flags,svetlo	;testuj pozadavek zda sviti nebo ne
	goto	IntRet
	btfss	v_lustru		;testuj, zda jde o zapojeni v lustru, pokud ano nacti predvolbu pro sepnuti okamzite - aktivni L
	goto	naplno
		MOVLW	0FBH
		MOVWF TMR1H
		MOVLW	00H ;natahni predvolbu low
		MOVWF	TMR1L
		bsf		T1CON,TMR1ON
	goto	IntRet
naplno	
		MOVLW	0FFH
		MOVWF TMR1H
		MOVLW	0FFH ;natahni predvolbu low
		MOVWF	TMR1L
		bsf		T1CON,TMR1ON
	goto	IntRet
	
;-----------------------------------------------------------------------------------------
	
external
	bcf INTCON,INTF ; nulovn prznaku preruen od external
	bcf	INTCON,T0IE;zakaz int od casovace
	movf	citac,W
		
	sublw	0C0H		;test prvniho byte, ten neni platny zahodi se (hodnota ve vyssim nibble nulova)
	btfsc	STATUS,C
	goto	out	
	movf	citac,W	;obnov data
	
	btfss	tlacitko	;test bitu,pokud je v nule,zaznamenava data do RAM
	goto	zaznam_01
	goto	porovnej
	
	
;zaznam dat do RAM
zaznam_01
	bcf		flags,stisk		;shodi priznak dalsiho preteceni casovace
	btfsc	flags,druhy_kod
	goto	zaznam_02

	incf	FSR,F
	movwf	INDF	;uloz hodnotu na misto indexovane FSR


out	call 	timini		;nacti predvolbu
	bsf		INTCON,T0IE	;povol int od casovace
	goto	IntRet	;8


zaznam_02
	
	incf	FSR,F
	movf	FSR,W		;uschovej FSR
	movwf	tmp
	addlw	7BH
	movwf	FSR
	movf	citac,W	;obnov data
	movwf	INDF	;uloz hodnotu na misto indexovane FSR

 
	movf	tmp,W
	movwf	FSR
	goto	out


;porovna hodnotu,pokud je rovno nastavi priznak ok
porovnej	bcf		flags,stisk		;shodi priznak dalsiho preteceni casovace
			incf	FSR,F
			movf	FSR,W			;uschovej 
			movwf	tmp				;v TMP je FSR
			movlw	25H				;proved presun na adresu v EEPROM (26H v FSR = 01H v EEPROM pro prvni kod)
			subwf	tmp,W
			
;********************   Cten dat z EEPROM    ********************
			
			bsf	STATUS,RP0	; banka 1	!!! nastav EEADR !!!
			movwf	EEADR
			bsf	EECON1,RD	; precte EEPROM
			movf	EEDATA,W	; EEDATA -> W
			bcf	STATUS,RP0	; banka 0
			movwf	tmp		;uloz data z EEPROM do tmp
			movf	citac,W	;nacti data z casovace
			subwf	tmp,W	;od W odecte INDF
  			btfsc	STATUS,Z	;testuj nulovost,nula je ok
			goto	pokr_03
						
			
;==============zkus odecet dat z RAM page 1 a pokud i tam nebude uspech, je to neplatny povel - chyba =========
				
			
			movf	FSR,W		;uschovej FSR
			movwf	tmp
			addlw	1BH			;pricti pro adresaci v druhe casti EEPROM, 26H+1BH=41H adresa prvniho zaznamu v druhe casti
			
		
;********************   Cten dat z EEPROM    ********************
			
			bsf	STATUS,RP0	; banka 1	!!! nastav EEADR !!!
			movwf	EEADR
			bsf	EECON1,RD	; precte EEPROM
			movf	EEDATA,W	; EEDATA -> W
			bcf	STATUS,RP0	; banka 0
			movwf	tmp		;uloz data z EEPROM do tmp
			movf	citac,W	;nacti data z casovace
			subwf	tmp,W	;od W odecte INDF
  			btfsc	STATUS,Z	;testuj nulovost,nula je ok
			goto	pokr_03
			goto	spatne
				

pokr_03		call 	timini		;nacti predvolbu
			bsf		INTCON,T0IE	;povol int od casovace
			goto	IntRet

			
;nuluje priznak ok pokud se data v RAM nerovnaji nactenym
spatne		bsf		flags,err	;
			call 	timini		;nacti predvolbu
			bsf		INTCON,T0IE	;povol int od casovace
			goto	IntRet


;----------natahni data zpet-----------------------
        
IntRet swapf TMPS,W ; pvodn registr STATUS do W 
  movwf STATUS ; navrcen registru STATUS 
  swapf TMPW,F ; prprava pvodnho registru W 
  swapf TMPW,W ; nvrat pvodnho registru W 
  retfie 


;timer pretece po konci telegramu
timer		bcf INTCON,T0IF ; nulovn prznaku preruen 
			incf	citac,F		;inkrementuj software casovac 
			
			movf	citac,W		;nacti
			btfss	STATUS,Z	;testuj preteceni
			goto	IntRet		;nepretekl, ven, pretekl, pokracuj dal
			
;=======CASOVAC PRETEKL t.j. ukonceni serie impulsu=======================	
	
			
			btfss	flags,stisk		;podruhe preteceni bez prichodu impulsu, t.j. tlacitko na DO uvolneno
			goto	pokr_01			
			
			bcf		INTCON,T0IE	;zakaz int od casovace-vypni casovac
			
			btfss	flags,prijato_ok
			goto	pokr_07
		
			movf	obehy,W		;nacti obehy
			sublw	konst		;odecti konstantu, jeji velikost ovlivnuje, po jake dobe se prejde po stisku do stmivani
			btfsc	STATUS,Z	;testuj vysledek
			goto	pokr_07		;docasovano,stmivalo se nebo rozsvicovalo,nedelej nic
			
			btfss	flags,svetlo	;neni docasovano, je pozadavek rozsviceni nebo zhasnuti testuj stav svetla
								; zde jeste mozno doplnit jeden test obehu (na dosazene cislo) kvuli vylouceni
								;rozsviceni nebo zhasnuti pri kratkodobem vypadku infra telegramu
			goto	pokr_08
			
			
			btfss	flags1,cykl
			goto	pokr_50
			btfss	jumper		;zde se testuje, zda budeme pracovat v modu stmivani nebo jen jako spinac
			goto	pokr_50
			bcf		flags1,cykl
			btfss	flags,stmivej	;po uvolneni tlacitka se zmeni smer  stmivani / rozsveceni
			goto 	zmen			;tento smer se zmeni i po prijeti neplatneho kod, to ale neni na zavadu
			bcf		flags,stmivej	;stejne neni predem znamo, zda bude pozadavek stmivani nebo rozsveceni
			goto	pokr_07			; a pri jinem pozadavku se bude muset stejne stisknout dvakrat
zmen		bsf		flags,stmivej
			goto	pokr_07
			
pokr_50		bcf		flags,svetlo	;zhasni	

		
			bcf		flags1,rozsviceno	;pri zhasnuti nuluj flag pro rychle roztmivani
			movf	initmrhi1,W		;uschovej hodnotu predvolby pro rozetmeni pro rychle zapnuti
			movwf	tmphi
			movlw	minimalni_jas			;zadej hodnotu pro pristi zapnuti u stmivace pro rychle rozetmeni,toto je hodnota minimalniho jasu			
			movwf	initmrhi1		
	
			goto	pokr_07
pokr_08		bsf		flags,svetlo	;rozsvit			
	
pokr_07		clrf	obehy			;nuluj pocitadlo obehu
	
		
			bcf		flags,prijato_ok	;nuluj priznak prijeti platneho kodu
		
	
;--------odtud je to OK-----------			
			btfsc	tlacitko
			goto	zhasni

			btfss	flags,druhy_kod		
			goto	pokr_05
			call	zapisEEPROM			;zapis kodu z RAM do EEPROM - 2.kod
			bcf		flags,druhy_kod
			goto	zhasni	
			
pokr_05	
			call	zapisEEPROM			;zapis kodu z RAM do EEPROM - 1.kod
			bsf	flags,druhy_kod			
			goto	zhasni

;tohle se vykonava po ukonceni serie impulsu			
pokr_01		movf	FSR,W		;pri jednom pulsu na vstupu se spusti  casovac a pretece, pak doslo k "sepnuti"
			sublw	29H			;zde se testuje, kolik prislo pulsu, pokud jen 4 a mene je to chyba nedela nic	
			btfss	STATUS,C	;toto osetreni odstrani i pokud nahodou prijdou napr 2 rusive pulsy, jejichz delka je "spravna"
								;coz se tyka zaznamu v EEPROM. Tim err bit neni nastaven, dojde k preteceni a byl to chybne interpretovany platny stav			
								;proste musi prijit 5 a vice platnych pulsu z SFH
			btfsc	flags,err
			goto	zhasni
			bsf		led
;-------------Vlastni ovladani stmivace po prichodu O.K. kodu	
			bsf		flags,prijato_ok	;nastav priznak platneho prijeti kodu
			movf	obehy,W		;nacti obehy
			sublw	konst		;odecti konstantu, jeji velikost ovlivnuje, po jake dobe se prejde po stisku do stmivani
			btfsc	STATUS,Z	;testuj vysledek
			goto	pokr_06		;docasovano,stmivej nebo rozsvicuj
			incf	obehy,F		;zvys pocet obehu
			goto	konec		;a ven
pokr_06
	bsf		flags,svetlo	;rozsvit-zde je to proto,aby se pri vypnutem svetle pri dlouhem drzeni svetlo rozsvitilo,
							;aby se nemuselo stisknout DO 2x jednou pro rozsviceni,podruhe pro stmivani
	
	bsf		flags1,cykl
	movlw	03H
	movwf	zpomal
	goto	konec
	

		
zhasni		bcf		led
			bcf		flags,err
konec		movlw	25H			;nacti pocatecni pozici pro indirect addresing
			movwf	FSR
			bsf		flags,stisk
			goto	IntRet

;-------obsluha INT od casovace 1 - stmivac----------------
timer1
 	bcf		PIR1,TMR1IF		;shod priznak
 	bcf		T1CON,TMR1ON	;zastav casovac
	btfss	flags,svetlo	;pokud neni pozadavek svetla,nesvit vubec
    goto	IntRet
	bsf		vyst_triak			;spousteci impuls pro triak
	bsf		flags1,spusteni
		
	btfsc	flags1,podruhe	;pokud jiz tato rutinna jednou probehla i s casovanim 10 msec. 
							;nespoustej casovac
	goto	IntRet

	movlw	0D8H ; natahni predvolbu high predvolba pro 10 msec.
	MOVWF 	TMR1H
	MOVlw	0F0H ;natahni predvolbu low
	MOVWF	TMR1L
  	bsf		T1CON,TMR1ON	;spust casovac pro 10 msec.
  	bsf		flags1,podruhe	;nastav flag pro 2. nevstoupen do teto rutiny
    goto 	IntRet
;-----------------------------------------------------------

;obsluha INT od casovace 2 zajistuje ukonceni impulsu do gecka triaku pred ukoncenim pulperiody
timer2
 	bcf		PIR1,TMR2IF		;shod priznak
	incf	tim2,F
 	movf	porovnani,W
 	subwf	tim2,W
 	btfsc	STATUS,Z
	goto	konec_periody

	btfss	flags1,spusteni
	goto	nesvit
	bsf		vyst_triak
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
nesvit
	bcf		vyst_triak
	goto	IntRet


konec_periody
	bcf		vyst_triak			;ukonci impuls
	movlw	14H				;testuj druhy pruchod touto rutimou (pozna se to podle predvolby,pokud jiz je 10H
							;pak je to podruhe, pokud neni 10H, je to poprve a nacti tuto predvolbu)
	subwf	porovnani,W
	btfsc	STATUS,Z
	bcf		T2CON,TMR2ON	;zastav casovac
	
	movlw	14H
	movwf	porovnani
	clrf	tim2	
	bcf		flags1,spusteni
	goto 	IntRet
;-----------------------------------------------------------








;********************   Zpis dat do EEPROM   ********************
zapisEEPROM
		movlw	25H			;nastav ukazatel na dat v RAM prvni kod
		btfsc	flags,druhy_kod	;testuj odkud a kam zapsat,pokud je nastaven,provede se zapis prvnich dat do prvni casti EEPROM
		addlw	7BH			;pokud je pozadavek nacitani dat druheho kodu, pricti k ukazateli cislo pro prechod do druhe banky RAM
		movwf	FSR			;uloz do ukazatele
		
		clrW
		btfsc	flags,druhy_kod	;testuj odkud a kam zapsat,pokud je nastaven,provede se zapis prvnich dat do prvni casti EEPROM
		movlw	40H			;pokud jde o zaznam do prvni casti EEPROM,uloz do EEADR 0, pujde o zaznam od adresy 1
		bsf	STATUS,RP0	; banka 1	!!! nastav EEADR a EEDATA !!!
		movwf	EEADR		;pokud jde o zaznam do druhe casti EEPROM,uloz do EEADR 40, pujde o zaznam od adresy 41
		bcf	STATUS,RP0		
		
		clrf	tmp		;nuluj pocitadlo obehu zapisu
			
opak	incf 	FSR,F		;zvys FSR
		incf	tmp,F
		movf	tmp,W
		xorlw	40H		;testuj dosazeni konce
		btfsc	STATUS,Z
		goto	konec_zapisu

	bcf	INTCON,GIE	; !!! zakazano preruseni !!!
	movf	INDF,W	;nacti aktualni hodnotu	
	bsf	STATUS,RP0	; banka 1	!!! nastav EEADR a EEDATA !!!
	movwf	EEDATA		; !!! W -> EEDATA !!!
	incf	EEADR,F

	bsf	EECON1,WREN	; povolit zapis do EEPROM
;       ------------------------; aktivace zapisu
	movlw	0x55		; povinna povolovaci sekvence
	movwf	EECON2
	movlw	0xAA
	movwf	EECON2
	bsf	EECON1,WR	; spustit zapis
;       ------------------------; konec aktivace
	btfsc	EECON1,WR	; pockat na konec zapisu
	goto	$-1		; =1
	bcf	EECON1,WREN	; zakazat zapis do EEPROM
	bcf		STATUS,RP0	; banka 0
	goto	opak

konec_zapisu	
	bsf	INTCON,GIE	; !!! povoleni preruseni !!!
;-------------------------------
	return




; --------------------------------
; SET ANALOG/DIGITAL INPUTS PORT A
; --------------------------------
;
init	movlw 7
	movwf CMCON		; CMCON=7 set comparators off         
; 
; ---------------- 
; INITIALIZE PORTS
; ---------------- 
; 
	bcf STATUS,RP0		;banka 0
	movlw b'00000000'   ;set up portA
	movwf PORTA	
        
	movlw b'00011111'	; RB2(TX)=1 others are 0
    movwf PORTB

        bsf STATUS,RP0          ; RAM PAGE 1
		bcf OPTION_REG, 7		; enable internal pullups
		bcf	OPTION_REG,INTEDG

        movlw b'11100000'
        movwf TRISA		; portA

;----------PORT B-----------------------
       movlw b'00111111'	;  input 
       movwf TRISB
; ---------------- 
; INITIALIZE TIMERU / timer 0 is 8 bits timer
; ---------------- 
 	bcf OPTION_REG,PSA ; nastaven registru OPTION 
	bcf	OPTION_REG,PS0
	bcf	OPTION_REG,PS1
	bcf	OPTION_REG,PS2
	
	bcf	OPTION_REG,T0CS
	bcf INTCON,T0IF 
;--------------INICIALIZACE TIMERU 1 ----------------
	clrf STATUS ; Do initialization (Bank0)
	bcf T1CON, TMR1ON ; Timer1 is NOT incrementing

 ; vlastni init timeru

	clrf INTCON
	clrf PIR1
	movlw 0x0C			;preddelicka vypnuta
	movwf T1CON ; Enable T1 Oscillator, int Clock, Async, prescaler = 0
	
;---------INICIALIZACE TIMERU 2 ---------------------
	bsf	T2CON,T2CKPS0	;preddelicka 1:4
	bcf	T2CON,T2CKPS1
	bcf	T2CON,TOUTPS0	;postscale
	bcf	T2CON,TOUTPS1
	bcf	T2CON,TOUTPS2
	bcf	T2CON,TOUTPS3
	bcf	T2CON,TMR2ON	;casovac stoji
						;preruseni povoleno nize
	bcf	PIR1,TMR2IF		;nulovani priznaku, mozno vypustit, nuluje se vyse cely registr
	movlw	07DH     		;nacti predvolbu pro 9 msec.
	bsf	STATUS,RP0	; banka 1
	movwf	PR2
	bcf	STATUS,RP0	; banka 0


; Initialize the Special Function Registers (SFR) interrupts
	bsf STATUS, RP0 ; Bank1
	bsf PIE1, TMR1IE ; Enable TMR1 Interrupt
	bsf PIE1, TMR2IE ; Enable TMR2 Interrupt
	bcf STATUS, RP0 ; Bank0
	bsf INTCON, PEIE ; Enable all unmasked Peripheral Interrupts
;-----
	bsf INTCON, INTE ; Enable Peripheral Interrupt RB0
;-----
	bsf INTCON, GIE ; Enable all Interrupts
	bcf	STATUS,IRP	;
	bsf	INTCON,	RBIE	;povol INT zmenou na portu B

		
;init rpo stmivac
	movlw	minimalni_jas	
	movwf initmrhi1 ; natahni predvolbu high
	movlw	0H	
	movwf initmrlo1	; natahni predvolbu high
	call timini1	;volej init timeru-nacteni predvolby
	bcf		flags,stmivej	
	
;---------------------------------
;pro infra	
	
	movlw	25H
	movwf	FSR
	clrf	citac
	clrf	TMR0
	bcf		flags,druhy_kod
	bcf		flags,prijato_ok
	bcf		flags1,rozsviceno	
	movlw	0FAH
	movwf	tmphi
	clrf	obehy
	bcf		flags1,cykl
	bcf		flags,svetlo	;zhasni
	bcf		flags1,spusteni
	bcf		flags1,lustrak_uvolnen
;**********************************************************	
pokr_11		btfsc	vypinac		;testuj stav vypinace, v L je aktivni	
			goto	uvolnen		;testuj zda jde o prvni cyklus po uvolneni
			bsf		flags1,lustrak_uvolnen		;nastav priznak pro jedno vykonani rutiny po uvolneni lustraku	
			
;----protoze pri stisku lustraku se stmivani a rozsveceni zastavovalo a chvili trvalo i pri stisknutem lustraku
;nez to pokracovalo dal, je tady zablokovan vstup od SFH. Ten to dela, nevim proc, i kdyz jsem zablokoval INT
;tak to delalo, pri odpojeni vstupu od SFH nebo napajeni to fungovalo normalne. Pomohlo az prestaveni vstupu SFH na OUT

			bcf INTCON, INTE ; disable Peripheral Interrupt RB0-aby nemohlo byt vyvolano INT od SFH pri ovladani mistne 	
			bsf STATUS,RP0          ; RAM PAGE 1
			movlw b'00111110'	;  input 
       		movwf TRISB
			bcf STATUS,RP0          ; RAM PAGE 0
			bsf	PORTB,0
			call	cekacka1
			movf	obehy,W		;nacti obehy
			sublw	konst		;odecti konstantu, jeji velikost ovlivnuje, po jake dobe se prejde po stisku do stmivani
			btfsc	STATUS,Z	;testuj vysledek
			goto	pokr_10		;docasovano,stmivej nebo rozsvicuj
			incf	obehy,F		;zvys pocet obehu
			goto	pokr_11		;a ven
pokr_10
	bsf		flags,svetlo	;rozsvit-zde je to proto,aby se pri vypnutem svetle pri dlouhem drzeni svetlo rozsvitilo,
							;aby se nemuselo stisknout DO 2x jednou pro rozsviceni,podruhe pro stmivani
	bsf		flags1,cykl
	movlw	03H
	movwf	zpomal
	goto	pokr_11
	
				
uvolnen
	btfss	flags1,lustrak_uvolnen	;testuj priznak, zda jiz byla tato rutina jednou vykonana	
	goto	pokr_11					;ano,navrat
	bcf		flags1,lustrak_uvolnen	;ne, proved
		
		movf	obehy,W		;nacti obehy
		sublw	konst		;odecti konstantu, jeji velikost ovlivnuje, po jake dobe se prejde po stisku do stmivani
		btfsc	STATUS,Z	;testuj vysledek
		goto	pokr_14		;docasovano,stmivalo se nebo rozsvicovalo,nedelej nic a navrat
;test,pokud prisel jen jeden impuls rusivy nedelej nic	
		movf	obehy,W		;nacti obehy
		sublw	01H		;odecti konstantu, jeji velikost ovlivnuje, po jake dobe se prejde po stisku do stmivani
		btfsc	STATUS,Z	;testuj vysledek
		goto	pokr_14		;pokud je nula (Z=1) byl jeden impuls nedelej nic a ven
		
		btfss	flags,svetlo	;neni docasovano, je pozadavek rozsviceni nebo zhasnuti testuj stav svetla
							
		goto	pokr_12
		btfss	flags1,cykl
		goto	pokr_51
		btfss	jumper		;zde se testuje, zda budeme pracovat v modu stmivani nebo jen jako spinac
		goto	pokr_51
		
		bcf		flags1,cykl
		
		btfss	flags,stmivej	;po uvolneni tlacitka se zmeni smer  stmivani / rozsveceni
		goto 	zmen1			;tento smer se zmeni i po prijeti neplatneho kod, to ale neni na zavadu
		bcf		flags,stmivej	;stejne neni predem znamo, zda bude pozadavek stmivani nebo rozsveceni
		goto	pokr_14			; a pri jinem pozadavku se bude muset stejne stisknout dvakrat
zmen1	bsf		flags,stmivej	
		goto	pokr_14
		
pokr_51	bcf		flags,svetlo	;zhasni	

	
		
		bcf		flags1,rozsviceno	;pri zhasnuti nuluj flag pro rychle roztmivani
		movf	initmrhi1,W		;uschovej hodnotu predvolby pro rozetmeni pro rychle zapnuti
		movwf	tmphi
		movlw	minimalni_jas	;zadej hodnotu pro pristi zapnuti u stmivace pro rychle rozetmeni,toto je hodnota minimalniho jasu			
		movwf	initmrhi1		
	
		goto	pokr_14
pokr_12
		bsf		flags,svetlo	;rozsvit			
	
;---------------
pokr_14		clrf	obehy			;nuluj pocitadlo obehu
						
			bsf STATUS,RP0          ; RAM PAGE 1
			movlw b'00111111'	;  input 
       		movwf TRISB
			bcf STATUS,RP0          ; RAM PAGE 0
			bsf	PORTB,0
			bsf INTCON, INTE ; Enable Peripheral Interrupt RB0-aby nemohlo byt vyvolano INT od SFH pri ovladani mistne 
			goto	pokr_11
		
;----------------------------------------------------------------------------------------------------------
timini	MOVLW initmrhi ; natahni predvolbu high
		MOVWF citac
		CLRF	TMR0
		return
	
;predvolba pro timer1 - stmivac
timini1	
		MOVF initmrhi1,W ; natahni predvolbu high
		MOVWF TMR1H
		MOVF	initmrlo1,W ;natahni predvolbu low
		MOVWF	TMR1L
		return
  
  
cekacka  ;Variables: TMP1, TMP0
;Delay 99991 cycles
        MOVLW 0x0C6  ;198 DEC
        MOVWF TMP1
        MOVLW 0x0A7  ;167 DEC
        MOVWF TMP0
        DECFSZ TMP0,F
        GOTO $-1
        DECFSZ TMP1,F
        GOTO $-5
;End of Delay
	return

cekacka1
;Variables: TMP1, TMP0
;Delay 99991 cycles
        MOVLW 0x0C6  ;198 DEC
        MOVWF TMP1
        MOVLW 0x0A7  ;167 DEC
        MOVWF TMP0
        DECFSZ TMP0,F
        GOTO $-1
        DECFSZ TMP1,F
        GOTO $-5
;End of Delay
	return
  
  
  
  
        END
